//Controller for Tank iii: 2 joystick and 2 toggle switches

#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>

RF24 radio(8, 9); //CE, CSN
const byte address[6] = "00002";

typedef struct { //declare stucture
  int Lxj; //members
  int Lyj;
  int Rxj;
  int Ryj;
  int PotL;
  int PotR;
  int TS1;
  int TS2;
}Data;
Data value; //value is object

int ackData = -1;
int buttonPin1 = 5;
int buttonPin2 = 4;

void setup() {
  Serial.begin(9600);
  radio.begin();
  radio.enableAckPayload();
  radio.openWritingPipe(address);
  radio.setPALevel(RF24_PA_MIN);
  radio.stopListening();

  pinMode(buttonPin1, INPUT_PULLUP);
  pinMode(buttonPin2, INPUT_PULLUP);
  
}

void loop() {
  value.Lxj = analogRead(A0);//Read left joystick values from the X-axis
  value.Lyj = analogRead(A1);//Read left joystick values from the Y-axis
  value.Rxj = analogRead(A2);//Read Right joystick values from the X-axis
  value.Ryj = analogRead(A3);//Read Right joystick value from Y-axis
  value.PotL = analogRead(A4);//Read Left Potentiometer 
  value.PotR = analogRead(A5);//Read Right Potentiometer
  value.TS1 = digitalRead(buttonPin1);//Read Toggle switch value 1
  value.TS2 = digitalRead(buttonPin2);//Read Toggle switch value 2

  Serial.print("Lxj: ");
  Serial.print(value.Lxj);
  Serial.print("  Lyj: ");
  Serial.print(value.Lyj);
  Serial.print(" Rxj: ");
  Serial.print(value.Rxj);
  Serial.print("  Ryj: ");
  Serial.print(value.Ryj);
  Serial.print("  PotL: ");
  Serial.print(value.PotL);
  Serial.print("  PotR: ");
  Serial.print(value.PotR);
  Serial.print("  Button 1: ");
  Serial.print(value.TS1);
  Serial.print("  Button 2: ");
  Serial.print(value.TS2);
  Serial.print(" , ");
  Serial.print(sizeof(value));//Size of the object
  Serial.println();

  radio.write(&value, sizeof(value)); //Send data out
  if ( radio.isAckPayloadAvailable() ) {
    radio.read(&ackData, sizeof(ackData));
    Serial.print(" Data Received Count: ");
    Serial.print(ackData);   
  }
  else {
    Serial.print(" Data did not pass through ");
    delay(500);
  }

  delay(10);
  Serial.print( " Sending ");

}
